; uC Quelltext zu "PC Tastatur am Palm"
; (C) 2002 Christian Zietz <czietz@gmx.net>
; Quelltext ist fr ASEM-51 von W.W. Heinz 

                            ; ggf. BAUD an Taktrate anpassen
BAUD EQU 0FEh               ; Formel: 256 - (Quarzspeed / (16*12*9600))
; NUMBITS IS R0
; THEBYTE IS R1
TRIGGER BIT 0
KEYDAT  BIT P3.3

ORG     0
SJMP    START

ORG     EXTI0
AJMP    I0RTN

ORG     40h
START:
MOV     SP, #60h            ; Stackpointer setzen
MOV     TMOD, #20h          ; Timer 1 im 8-bit Modus
MOV     TH1, #BAUD          ; Teiler
ORL     PCON, #80h          ; Baudratenverdopplung    
MOV     SCON, 0             ; Alles aus
SETB    SCON.6              ; 8-bit UART
SETB    TR1                 ; Timer 1 starten
SETB    TI                  ; zum Senden bereit

SETB    IT0                 ; Interrupt 0 flanken-getriggert
MOV     IP, #1              ; Interrupt 0 hat hchste Prioritt
MOV     IE, #1              ; Interrupt 0 einschalten ...
SETB    EA                  ; ... und freigeben    
MOV     R0, #0
CLR     TRIGGER

REDO:
ORL     PCON, #1                ; idle Modus
JNB     TRIGGER, REDO           ; Taste angekommen?
WAIT:
JNB     TI, WAIT                ; auf Sendemglichkeit warten
CLR     TI
CLR     TRIGGER
MOV     A, R1
JZ      REDO
MOV     SBUF, A                 ; Senden
SJMP    REDO

I0RTN:
MOV     A, R0
JZ      IGNORE                  ; Startbit empfagen, ignorieren
CJNE    A, #10, BITS19          ; Stopbit empfangen, Byte komplett
MOV     R0, #0
SETB    TRIGGER
RETI
BITS19:
CJNE    A, #9, BITS18           ; Paritt ignorieren
SJMP    IGNORE
BITS18:
MOV     C, KEYDAT
MOV     A, R1
RR      A
MOV     ACC.7, C
MOV     R1, A
IGNORE:
INC     R0
RETI

END
